/****************************************************************************
**
** Copyright (C) 2016 The Qt Company Ltd.
** Contact: https://www.qt.io/licensing/
**
** This file is part of Qt for Python.
**
** $QT_BEGIN_LICENSE:LGPL$
** Commercial License Usage
** Licensees holding valid commercial Qt licenses may use this file in
** accordance with the commercial license agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and The Qt Company. For licensing terms
** and conditions see https://www.qt.io/terms-conditions. For further
** information use the contact form at https://www.qt.io/contact-us.
**
** GNU Lesser General Public License Usage
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 3 as published by the Free Software
** Foundation and appearing in the file LICENSE.LGPL3 included in the
** packaging of this file. Please review the following information to
** ensure the GNU Lesser General Public License version 3 requirements
** will be met: https://www.gnu.org/licenses/lgpl-3.0.html.
**
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU
** General Public License version 2.0 or (at your option) the GNU General
** Public license version 3 or any later version approved by the KDE Free
** Qt Foundation. The licenses are as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL2 and LICENSE.GPL3
** included in the packaging of this file. Please review the following
** information to ensure the GNU General Public License requirements will
** be met: https://www.gnu.org/licenses/gpl-2.0.html and
** https://www.gnu.org/licenses/gpl-3.0.html.
**
** $QT_END_LICENSE$
**
****************************************************************************/

//workaround to access protected functions
#define protected public

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QDebug>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <pysideqenum.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED

#include <typeinfo>
#include <iterator>

// module include
#include "pyside6_qtbluetooth_python.h"

// main header
#include "qlowenergycharacteristic_wrapper.h"

// inner classes

// Extra includes
#include <QList>
#include <QtBluetooth/qbluetoothuuid.h>
#include <QtBluetooth/qlowenergycharacteristic.h>
#include <QtBluetooth/qlowenergydescriptor.h>
#include <qbytearray.h>


#include <cctype>
#include <cstring>



template <class T>
static const char *typeNameOf(const T &t)
{
    const char *typeName =  typeid(t).name();
    auto size = std::strlen(typeName);
#if defined(Q_CC_MSVC) // MSVC: "class QPaintDevice * __ptr64"
    if (auto lastStar = strchr(typeName, '*')) {
        // MSVC: "class QPaintDevice * __ptr64"
        while (*--lastStar == ' ') {
        }
        size = lastStar - typeName + 1;
    }
#else // g++, Clang: "QPaintDevice *" -> "P12QPaintDevice"
    if (size > 2 && typeName[0] == 'P' && std::isdigit(typeName[1])) {
        ++typeName;
        --size;
    }
#endif
    char *result = new char[size + 1];
    result[size] = '\0';
    memcpy(result, typeName, size);
    return result;
}


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QLowEnergyCharacteristic_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SbkObject *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QLowEnergyCharacteristic >()))
        return -1;

    ::QLowEnergyCharacteristic *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QLowEnergyCharacteristic.__init__";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "QLowEnergyCharacteristic", 0, 1, &(pyArgs[0])))
        return -1;


    // Overloaded function decisor
    // 0: QLowEnergyCharacteristic::QLowEnergyCharacteristic()
    // 1: QLowEnergyCharacteristic::QLowEnergyCharacteristic(QLowEnergyCharacteristic)
    if (numArgs == 0) {
        overloadId = 0; // QLowEnergyCharacteristic()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_IDX], (pyArgs[0])))) {
        overloadId = 1; // QLowEnergyCharacteristic(QLowEnergyCharacteristic)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QLowEnergyCharacteristic_Init_TypeError;

    // Call function/method
    switch (overloadId) {
        case 0: // QLowEnergyCharacteristic()
        {

            if (!PyErr_Occurred()) {
                // QLowEnergyCharacteristic()
                cptr = new ::QLowEnergyCharacteristic();
            }
            break;
        }
        case 1: // QLowEnergyCharacteristic(const QLowEnergyCharacteristic & other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QLowEnergyCharacteristic *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (!PyErr_Occurred()) {
                // QLowEnergyCharacteristic(QLowEnergyCharacteristic)
                cptr = new ::QLowEnergyCharacteristic(*cppArg0);
            }
            break;
        }
    }

    if (PyErr_Occurred() || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QLowEnergyCharacteristic >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (!cptr) goto Sbk_QLowEnergyCharacteristic_Init_TypeError;

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;

    Sbk_QLowEnergyCharacteristic_Init_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        return -1;
}

static PyObject *Sbk_QLowEnergyCharacteristicFunc_clientCharacteristicConfiguration(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QLowEnergyCharacteristic *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QLowEnergyCharacteristic.clientCharacteristicConfiguration";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // clientCharacteristicConfiguration()const
            QLowEnergyDescriptor* cppResult = new QLowEnergyDescriptor(const_cast<const ::QLowEnergyCharacteristic *>(cppSelf)->clientCharacteristicConfiguration());
            pyResult = Shiboken::Object::newObject(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYDESCRIPTOR_IDX], cppResult, true, true);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QLowEnergyCharacteristicFunc_descriptor(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QLowEnergyCharacteristic *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QLowEnergyCharacteristic.descriptor";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QLowEnergyCharacteristic::descriptor(QBluetoothUuid)const->QLowEnergyDescriptor
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHUUID_IDX], (pyArg)))) {
        overloadId = 0; // descriptor(QBluetoothUuid)const
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QLowEnergyCharacteristicFunc_descriptor_TypeError;

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QBluetoothUuid cppArg0_local;
        ::QBluetoothUuid *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (!PyErr_Occurred()) {
            // descriptor(QBluetoothUuid)const
            QLowEnergyDescriptor* cppResult = new QLowEnergyDescriptor(const_cast<const ::QLowEnergyCharacteristic *>(cppSelf)->descriptor(*cppArg0));
            pyResult = Shiboken::Object::newObject(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYDESCRIPTOR_IDX], cppResult, true, true);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_QLowEnergyCharacteristicFunc_descriptor_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        return {};
}

static PyObject *Sbk_QLowEnergyCharacteristicFunc_descriptors(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QLowEnergyCharacteristic *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QLowEnergyCharacteristic.descriptors";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // descriptors()const
            QList<QLowEnergyDescriptor > cppResult = const_cast<const ::QLowEnergyCharacteristic *>(cppSelf)->descriptors();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtBluetoothTypeConverters[SBK_QTBLUETOOTH_QLIST_QLOWENERGYDESCRIPTOR_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QLowEnergyCharacteristicFunc_isValid(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QLowEnergyCharacteristic *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QLowEnergyCharacteristic.isValid";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // isValid()const
            bool cppResult = const_cast<const ::QLowEnergyCharacteristic *>(cppSelf)->isValid();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QLowEnergyCharacteristicFunc_name(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QLowEnergyCharacteristic *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QLowEnergyCharacteristic.name";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // name()const
            QString cppResult = const_cast<const ::QLowEnergyCharacteristic *>(cppSelf)->name();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QLowEnergyCharacteristicFunc_properties(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QLowEnergyCharacteristic *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QLowEnergyCharacteristic.properties";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // properties()const
            QFlags<QLowEnergyCharacteristic::PropertyType> cppResult = const_cast<const ::QLowEnergyCharacteristic *>(cppSelf)->properties();
            pyResult = Shiboken::Conversions::copyToPython(PepType_PFTP(reinterpret_cast<PySideQFlagsType *>(SbkPySide6_QtBluetoothTypes[SBK_QFLAGS_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX]))->converter, &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QLowEnergyCharacteristicFunc_uuid(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QLowEnergyCharacteristic *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QLowEnergyCharacteristic.uuid";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // uuid()const
            QBluetoothUuid cppResult = const_cast<const ::QLowEnergyCharacteristic *>(cppSelf)->uuid();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHUUID_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QLowEnergyCharacteristicFunc_value(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QLowEnergyCharacteristic *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QLowEnergyCharacteristic.value";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // value()const
            QByteArray cppResult = const_cast<const ::QLowEnergyCharacteristic *>(cppSelf)->value();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypes[SBK_QBYTEARRAY_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QLowEnergyCharacteristic_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QLowEnergyCharacteristic_methods[] = {
    {"clientCharacteristicConfiguration", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyCharacteristicFunc_clientCharacteristicConfiguration), METH_NOARGS},
    {"descriptor", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyCharacteristicFunc_descriptor), METH_O},
    {"descriptors", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyCharacteristicFunc_descriptors), METH_NOARGS},
    {"isValid", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyCharacteristicFunc_isValid), METH_NOARGS},
    {"name", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyCharacteristicFunc_name), METH_NOARGS},
    {"properties", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyCharacteristicFunc_properties), METH_NOARGS},
    {"uuid", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyCharacteristicFunc_uuid), METH_NOARGS},
    {"value", reinterpret_cast<PyCFunction>(Sbk_QLowEnergyCharacteristicFunc_value), METH_NOARGS},

    {nullptr, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QLowEnergyCharacteristic_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QLowEnergyCharacteristic *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_IDX], (pyArg)))) {
                // operator!=(const QLowEnergyCharacteristic & b)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QLowEnergyCharacteristic *cppArg0;
                pythonToCpp(pyArg, &cppArg0);
                bool cppResult = cppSelf !=(*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_IDX], (pyArg)))) {
                // operator==(const QLowEnergyCharacteristic & b)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QLowEnergyCharacteristic *cppArg0;
                pythonToCpp(pyArg, &cppArg0);
                bool cppResult = cppSelf ==(*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
            goto Sbk_QLowEnergyCharacteristic_RichComparison_TypeError;
    }

    if (pyResult && !PyErr_Occurred())
        return pyResult;
    Sbk_QLowEnergyCharacteristic_RichComparison_TypeError:
    PyErr_SetString(PyExc_NotImplementedError, "operator not implemented.");
    return {};

}

} // extern "C"

static int Sbk_QLowEnergyCharacteristic_traverse(PyObject *self, visitproc visit, void *arg)
{
    return SbkObject_TypeF()->tp_traverse(self, visit, arg);
}
static int Sbk_QLowEnergyCharacteristic_clear(PyObject *self)
{
    return reinterpret_cast<PyTypeObject *>(SbkObject_TypeF())->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QLowEnergyCharacteristic_Type = nullptr;
static PyTypeObject *Sbk_QLowEnergyCharacteristic_TypeF(void)
{
    return _Sbk_QLowEnergyCharacteristic_Type;
}

static PyType_Slot Sbk_QLowEnergyCharacteristic_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_repr,        nullptr},
    {Py_tp_hash,        nullptr},
    {Py_tp_call,        nullptr},
    {Py_tp_str,         nullptr},
    {Py_tp_getattro,    nullptr},
    {Py_tp_setattro,    nullptr},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QLowEnergyCharacteristic_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QLowEnergyCharacteristic_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QLowEnergyCharacteristic_richcompare)},
    {Py_tp_iter,        nullptr},
    {Py_tp_iternext,    nullptr},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QLowEnergyCharacteristic_methods)},
    {Py_tp_getset,      nullptr},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QLowEnergyCharacteristic_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObjectTpNew)},
    {0, nullptr}
};
static PyType_Spec Sbk_QLowEnergyCharacteristic_spec = {
    "2:PySide6.QtBluetooth.QLowEnergyCharacteristic",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QLowEnergyCharacteristic_slots
};

} //extern "C"

PyObject *SbkPySide6_QtBluetooth_QLowEnergyCharacteristic_PropertyType___and__(PyObject *self, PyObject *pyArg)
{
    ::QLowEnergyCharacteristic::PropertyTypes cppResult, cppSelf, cppArg;
    cppSelf = static_cast<::QLowEnergyCharacteristic::PropertyTypes>(int(PyLong_AsLong(self)));
    if (PyErr_Occurred())
        return nullptr;
    cppArg = static_cast<QLowEnergyCharacteristic::PropertyTypes>(int(PyLong_AsLong(pyArg)));
    if (PyErr_Occurred())
        return nullptr;
    cppResult = cppSelf & cppArg;
    return Shiboken::Conversions::copyToPython(PepType_PFTP(reinterpret_cast<PySideQFlagsType *>(SbkPySide6_QtBluetoothTypes[SBK_QFLAGS_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX]))->converter, &cppResult);
}

PyObject *SbkPySide6_QtBluetooth_QLowEnergyCharacteristic_PropertyType___or__(PyObject *self, PyObject *pyArg)
{
    ::QLowEnergyCharacteristic::PropertyTypes cppResult, cppSelf, cppArg;
    cppSelf = static_cast<::QLowEnergyCharacteristic::PropertyTypes>(int(PyLong_AsLong(self)));
    if (PyErr_Occurred())
        return nullptr;
    cppArg = static_cast<QLowEnergyCharacteristic::PropertyTypes>(int(PyLong_AsLong(pyArg)));
    if (PyErr_Occurred())
        return nullptr;
    cppResult = cppSelf | cppArg;
    return Shiboken::Conversions::copyToPython(PepType_PFTP(reinterpret_cast<PySideQFlagsType *>(SbkPySide6_QtBluetoothTypes[SBK_QFLAGS_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX]))->converter, &cppResult);
}

PyObject *SbkPySide6_QtBluetooth_QLowEnergyCharacteristic_PropertyType___xor__(PyObject *self, PyObject *pyArg)
{
    ::QLowEnergyCharacteristic::PropertyTypes cppResult, cppSelf, cppArg;
    cppSelf = static_cast<::QLowEnergyCharacteristic::PropertyTypes>(int(PyLong_AsLong(self)));
    if (PyErr_Occurred())
        return nullptr;
    cppArg = static_cast<QLowEnergyCharacteristic::PropertyTypes>(int(PyLong_AsLong(pyArg)));
    if (PyErr_Occurred())
        return nullptr;
    cppResult = cppSelf ^ cppArg;
    return Shiboken::Conversions::copyToPython(PepType_PFTP(reinterpret_cast<PySideQFlagsType *>(SbkPySide6_QtBluetoothTypes[SBK_QFLAGS_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX]))->converter, &cppResult);
}

PyObject *SbkPySide6_QtBluetooth_QLowEnergyCharacteristic_PropertyType___invert__(PyObject *self, PyObject *pyArg)
{
    ::QLowEnergyCharacteristic::PropertyTypes cppSelf;
    Shiboken::Conversions::pythonToCppCopy(PepType_PFTP(reinterpret_cast<PySideQFlagsType *>(SbkPySide6_QtBluetoothTypes[SBK_QFLAGS_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX]))->converter, self, &cppSelf);
    ::QLowEnergyCharacteristic::PropertyTypes cppResult = ~cppSelf;
    return Shiboken::Conversions::copyToPython(PepType_PFTP(reinterpret_cast<PySideQFlagsType *>(SbkPySide6_QtBluetoothTypes[SBK_QFLAGS_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX]))->converter, &cppResult);
}

static PyObject *SbkPySide6_QtBluetooth_QLowEnergyCharacteristic_PropertyType_long(PyObject *self)
{
    int val;
    Shiboken::Conversions::pythonToCppCopy(PepType_PFTP(reinterpret_cast<PySideQFlagsType *>(SbkPySide6_QtBluetoothTypes[SBK_QFLAGS_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX]))->converter, self, &val);
    return Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &val);
}
static int SbkPySide6_QtBluetooth_QLowEnergyCharacteristic_PropertyType__nonzero(PyObject *self)
{
    int val;
    Shiboken::Conversions::pythonToCppCopy(PepType_PFTP(reinterpret_cast<PySideQFlagsType *>(SbkPySide6_QtBluetoothTypes[SBK_QFLAGS_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX]))->converter, self, &val);
    return val != 0;
}

static PyType_Slot SbkPySide6_QtBluetooth_QLowEnergyCharacteristic_PropertyType_number_slots[] = {
    {Py_nb_bool,    reinterpret_cast<void *>(SbkPySide6_QtBluetooth_QLowEnergyCharacteristic_PropertyType__nonzero)},
    {Py_nb_invert,  reinterpret_cast<void *>(SbkPySide6_QtBluetooth_QLowEnergyCharacteristic_PropertyType___invert__)},
    {Py_nb_and,     reinterpret_cast<void *>(SbkPySide6_QtBluetooth_QLowEnergyCharacteristic_PropertyType___and__)},
    {Py_nb_xor,     reinterpret_cast<void *>(SbkPySide6_QtBluetooth_QLowEnergyCharacteristic_PropertyType___xor__)},
    {Py_nb_or,      reinterpret_cast<void *>(SbkPySide6_QtBluetooth_QLowEnergyCharacteristic_PropertyType___or__)},
    {Py_nb_int,     reinterpret_cast<void *>(SbkPySide6_QtBluetooth_QLowEnergyCharacteristic_PropertyType_long)},
    {Py_nb_index,   reinterpret_cast<void *>(SbkPySide6_QtBluetooth_QLowEnergyCharacteristic_PropertyType_long)},
    {0, nullptr} // sentinel
};



// Type conversion functions.

// Python to C++ enum conversion.
static void QLowEnergyCharacteristic_PropertyType_PythonToCpp_QLowEnergyCharacteristic_PropertyType(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QLowEnergyCharacteristic::PropertyType *>(cppOut) =
        static_cast<::QLowEnergyCharacteristic::PropertyType>(Shiboken::Enum::getValue(pyIn));

}
static PythonToCppFunc is_QLowEnergyCharacteristic_PropertyType_PythonToCpp_QLowEnergyCharacteristic_PropertyType_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX]))
        return QLowEnergyCharacteristic_PropertyType_PythonToCpp_QLowEnergyCharacteristic_PropertyType;
    return {};
}
static PyObject *QLowEnergyCharacteristic_PropertyType_CppToPython_QLowEnergyCharacteristic_PropertyType(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QLowEnergyCharacteristic::PropertyType *>(cppIn));
    return Shiboken::Enum::newItem(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX], castCppIn);

}

static void QFlags_QLowEnergyCharacteristic_PropertyType__PythonToCpp_QFlags_QLowEnergyCharacteristic_PropertyType_(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QFlags<QLowEnergyCharacteristic::PropertyType> *>(cppOut) =
        ::QFlags<QLowEnergyCharacteristic::PropertyType>(QFlag(int(PySide::QFlags::getValue(reinterpret_cast<PySideQFlagsObject *>(pyIn)))));

}
static PythonToCppFunc is_QFlags_QLowEnergyCharacteristic_PropertyType__PythonToCpp_QFlags_QLowEnergyCharacteristic_PropertyType__Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, SbkPySide6_QtBluetoothTypes[SBK_QFLAGS_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX]))
        return QFlags_QLowEnergyCharacteristic_PropertyType__PythonToCpp_QFlags_QLowEnergyCharacteristic_PropertyType_;
    return {};
}
static PyObject *QFlags_QLowEnergyCharacteristic_PropertyType__CppToPython_QFlags_QLowEnergyCharacteristic_PropertyType_(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QFlags<QLowEnergyCharacteristic::PropertyType> *>(cppIn));
    return reinterpret_cast<PyObject *>(PySide::QFlags::newObject(castCppIn, SbkPySide6_QtBluetoothTypes[SBK_QFLAGS_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX]));

}

static void QLowEnergyCharacteristic_PropertyType_PythonToCpp_QFlags_QLowEnergyCharacteristic_PropertyType_(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QFlags<QLowEnergyCharacteristic::PropertyType> *>(cppOut) =
        ::QFlags<QLowEnergyCharacteristic::PropertyType>(QFlag(int(Shiboken::Enum::getValue(pyIn))));

}
static PythonToCppFunc is_QLowEnergyCharacteristic_PropertyType_PythonToCpp_QFlags_QLowEnergyCharacteristic_PropertyType__Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX]))
        return QLowEnergyCharacteristic_PropertyType_PythonToCpp_QFlags_QLowEnergyCharacteristic_PropertyType_;
    return {};
}
static void number_PythonToCpp_QFlags_QLowEnergyCharacteristic_PropertyType_(PyObject *pyIn, void *cppOut)
{
    Shiboken::AutoDecRef pyLong(PyNumber_Long(pyIn));
    *reinterpret_cast<::QFlags<QLowEnergyCharacteristic::PropertyType> *>(cppOut) =
        ::QFlags<QLowEnergyCharacteristic::PropertyType>(QFlag(int(PyLong_AsLong(pyLong.object()))));

}
static PythonToCppFunc is_number_PythonToCpp_QFlags_QLowEnergyCharacteristic_PropertyType__Convertible(PyObject *pyIn)
{
    if (PyNumber_Check(pyIn) && PyObject_TypeCheck(pyIn, SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX]))
        return number_PythonToCpp_QFlags_QLowEnergyCharacteristic_PropertyType_;
    return {};
}
// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QLowEnergyCharacteristic_PythonToCpp_QLowEnergyCharacteristic_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QLowEnergyCharacteristic_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QLowEnergyCharacteristic_PythonToCpp_QLowEnergyCharacteristic_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, reinterpret_cast<PyTypeObject *>(Sbk_QLowEnergyCharacteristic_TypeF())))
        return QLowEnergyCharacteristic_PythonToCpp_QLowEnergyCharacteristic_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QLowEnergyCharacteristic_PTR_CppToPython_QLowEnergyCharacteristic(const void *cppIn)
{
    auto pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto tCppIn = reinterpret_cast<const ::QLowEnergyCharacteristic *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = typeNameOf(tCppIn);
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QLowEnergyCharacteristic_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QLowEnergyCharacteristic_SignatureStrings[] = {
    "1:PySide6.QtBluetooth.QLowEnergyCharacteristic(self)",
    "0:PySide6.QtBluetooth.QLowEnergyCharacteristic(self,other:PySide6.QtBluetooth.QLowEnergyCharacteristic)",
    "PySide6.QtBluetooth.QLowEnergyCharacteristic.clientCharacteristicConfiguration(self)->PySide6.QtBluetooth.QLowEnergyDescriptor",
    "PySide6.QtBluetooth.QLowEnergyCharacteristic.descriptor(self,uuid:typing.Union[PySide6.QtBluetooth.QBluetoothUuid, PySide6.QtBluetooth.QBluetoothUuid.CharacteristicType, PySide6.QtBluetooth.QBluetoothUuid.DescriptorType, PySide6.QtBluetooth.QBluetoothUuid.ProtocolUuid, PySide6.QtBluetooth.QBluetoothUuid.ServiceClassUuid, PySide6.QtCore.QUuid])->PySide6.QtBluetooth.QLowEnergyDescriptor",
    "PySide6.QtBluetooth.QLowEnergyCharacteristic.descriptors(self)->QList[PySide6.QtBluetooth.QLowEnergyDescriptor]",
    "PySide6.QtBluetooth.QLowEnergyCharacteristic.isValid(self)->bool",
    "PySide6.QtBluetooth.QLowEnergyCharacteristic.name(self)->QString",
    "PySide6.QtBluetooth.QLowEnergyCharacteristic.properties(self)->PySide6.QtBluetooth.QLowEnergyCharacteristic.PropertyTypes",
    "PySide6.QtBluetooth.QLowEnergyCharacteristic.uuid(self)->PySide6.QtBluetooth.QBluetoothUuid",
    "PySide6.QtBluetooth.QLowEnergyCharacteristic.value(self)->PySide6.QtCore.QByteArray",
    nullptr}; // Sentinel

void init_QLowEnergyCharacteristic(PyObject *module)
{
    _Sbk_QLowEnergyCharacteristic_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QLowEnergyCharacteristic",
        "QLowEnergyCharacteristic*",
        &Sbk_QLowEnergyCharacteristic_spec,
        &Shiboken::callCppDestructor< ::QLowEnergyCharacteristic >,
        0,
        0,
        0);
    auto *pyType = Sbk_QLowEnergyCharacteristic_TypeF(); // references _Sbk_QLowEnergyCharacteristic_Type
    InitSignatureStrings(pyType, QLowEnergyCharacteristic_SignatureStrings);
    SbkObjectType_SetPropertyStrings(reinterpret_cast<PyTypeObject *>(_Sbk_QLowEnergyCharacteristic_Type), Sbk_QLowEnergyCharacteristic_PropertyStrings);
    SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_IDX]
        = Sbk_QLowEnergyCharacteristic_TypeF();

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(Sbk_QLowEnergyCharacteristic_TypeF(),
        QLowEnergyCharacteristic_PythonToCpp_QLowEnergyCharacteristic_PTR,
        is_QLowEnergyCharacteristic_PythonToCpp_QLowEnergyCharacteristic_PTR_Convertible,
        QLowEnergyCharacteristic_PTR_CppToPython_QLowEnergyCharacteristic);

    Shiboken::Conversions::registerConverterName(converter, "QLowEnergyCharacteristic");
    Shiboken::Conversions::registerConverterName(converter, "QLowEnergyCharacteristic*");
    Shiboken::Conversions::registerConverterName(converter, "QLowEnergyCharacteristic&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QLowEnergyCharacteristic).name());


    // Initialization of enums.

    // Initialization of enum 'PropertyType'.
    SbkPySide6_QtBluetoothTypes[SBK_QFLAGS_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX] = PySide::QFlags::create("2:PySide6.QtBluetooth.QLowEnergyCharacteristic.PropertyTypes", SbkPySide6_QtBluetooth_QLowEnergyCharacteristic_PropertyType_number_slots);
    SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX] = Shiboken::Enum::createScopedEnum(Sbk_QLowEnergyCharacteristic_TypeF(),
        "PropertyType",
        "2:PySide6.QtBluetooth.QLowEnergyCharacteristic.PropertyType",
        "QLowEnergyCharacteristic::PropertyType",
        SbkPySide6_QtBluetoothTypes[SBK_QFLAGS_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX]);
    if (!SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX])
        return;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX],
        Sbk_QLowEnergyCharacteristic_TypeF(), "Unknown", (long) QLowEnergyCharacteristic::PropertyType::Unknown))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX],
        Sbk_QLowEnergyCharacteristic_TypeF(), "Broadcasting", (long) QLowEnergyCharacteristic::PropertyType::Broadcasting))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX],
        Sbk_QLowEnergyCharacteristic_TypeF(), "Read", (long) QLowEnergyCharacteristic::PropertyType::Read))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX],
        Sbk_QLowEnergyCharacteristic_TypeF(), "WriteNoResponse", (long) QLowEnergyCharacteristic::PropertyType::WriteNoResponse))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX],
        Sbk_QLowEnergyCharacteristic_TypeF(), "Write", (long) QLowEnergyCharacteristic::PropertyType::Write))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX],
        Sbk_QLowEnergyCharacteristic_TypeF(), "Notify", (long) QLowEnergyCharacteristic::PropertyType::Notify))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX],
        Sbk_QLowEnergyCharacteristic_TypeF(), "Indicate", (long) QLowEnergyCharacteristic::PropertyType::Indicate))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX],
        Sbk_QLowEnergyCharacteristic_TypeF(), "WriteSigned", (long) QLowEnergyCharacteristic::PropertyType::WriteSigned))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX],
        Sbk_QLowEnergyCharacteristic_TypeF(), "ExtendedProperty", (long) QLowEnergyCharacteristic::PropertyType::ExtendedProperty))
        return;
    // Register converter for enum 'QLowEnergyCharacteristic::PropertyType'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX],
            QLowEnergyCharacteristic_PropertyType_CppToPython_QLowEnergyCharacteristic_PropertyType);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QLowEnergyCharacteristic_PropertyType_PythonToCpp_QLowEnergyCharacteristic_PropertyType,
            is_QLowEnergyCharacteristic_PropertyType_PythonToCpp_QLowEnergyCharacteristic_PropertyType_Convertible);
        Shiboken::Enum::setTypeConverter(SbkPySide6_QtBluetoothTypes[SBK_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX], converter, false);
        Shiboken::Conversions::registerConverterName(converter, "QLowEnergyCharacteristic::PropertyType");
        Shiboken::Conversions::registerConverterName(converter, "PropertyType");
    }
    // Register converter for flag 'QFlags<QLowEnergyCharacteristic::PropertyType>'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(SbkPySide6_QtBluetoothTypes[SBK_QFLAGS_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX],
            QFlags_QLowEnergyCharacteristic_PropertyType__CppToPython_QFlags_QLowEnergyCharacteristic_PropertyType_);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QLowEnergyCharacteristic_PropertyType_PythonToCpp_QFlags_QLowEnergyCharacteristic_PropertyType_,
            is_QLowEnergyCharacteristic_PropertyType_PythonToCpp_QFlags_QLowEnergyCharacteristic_PropertyType__Convertible);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QFlags_QLowEnergyCharacteristic_PropertyType__PythonToCpp_QFlags_QLowEnergyCharacteristic_PropertyType_,
            is_QFlags_QLowEnergyCharacteristic_PropertyType__PythonToCpp_QFlags_QLowEnergyCharacteristic_PropertyType__Convertible);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            number_PythonToCpp_QFlags_QLowEnergyCharacteristic_PropertyType_,
            is_number_PythonToCpp_QFlags_QLowEnergyCharacteristic_PropertyType__Convertible);
        Shiboken::Enum::setTypeConverter(SbkPySide6_QtBluetoothTypes[SBK_QFLAGS_QLOWENERGYCHARACTERISTIC_PROPERTYTYPE_IDX], converter, true);
        Shiboken::Conversions::registerConverterName(converter, "QLowEnergyCharacteristic::PropertyTypes");
        Shiboken::Conversions::registerConverterName(converter, "PropertyTypes");
        Shiboken::Conversions::registerConverterName(converter, "QFlags<QLowEnergyCharacteristic::PropertyType>");
    }
    // End of 'PropertyType' enum/flags.

    qRegisterMetaType< ::QLowEnergyCharacteristic::PropertyType >("QLowEnergyCharacteristic::PropertyType");
    qRegisterMetaType< ::QLowEnergyCharacteristic::PropertyTypes >("QLowEnergyCharacteristic::PropertyTypes");
}

void init_QLowEnergyCharacteristicStaticFields()
{
    auto dict = reinterpret_cast<PyTypeObject *>(Sbk_QLowEnergyCharacteristic_TypeF())->tp_dict;
    PyDict_SetItemString(dict, "CCCDDisable",
                         Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypes[SBK_QBYTEARRAY_IDX], &QLowEnergyCharacteristic::CCCDDisable));
    PyDict_SetItemString(dict, "CCCDEnableNotification",
                         Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypes[SBK_QBYTEARRAY_IDX], &QLowEnergyCharacteristic::CCCDEnableNotification));
    PyDict_SetItemString(dict, "CCCDEnableIndication",
                         Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypes[SBK_QBYTEARRAY_IDX], &QLowEnergyCharacteristic::CCCDEnableIndication));

}
